------------------------------------------------------------------------------
--                                                                          --
--                            GNAT2WHY COMPONENTS                           --
--                                                                          --
--                   W H Y - A T R E E - M U T A T O R S                    --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                       Copyright (C) 2010-2025, AdaCore                   --
--                                                                          --
-- gnat2why is  free  software;  you can redistribute  it and/or  modify it --
-- under terms of the  GNU General Public License as published  by the Free --
-- Software  Foundation;  either version 3,  or (at your option)  any later --
-- version.  gnat2why is distributed  in the hope that  it will be  useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of  MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public License  distributed with  gnat2why;  see file COPYING3. --
-- If not,  go to  http://www.gnu.org/licenses  for a complete  copy of the --
-- license.                                                                 --
--                                                                          --
-- gnat2why is maintained by AdaCore (http://www.adacore.com)               --
--                                                                          --
------------------------------------------------------------------------------
--  This package is automatically generated by xtree. Do not edit manually.

with Why.Atree.Validity; use Why.Atree.Validity;
with Why.Conversions;    use Why.Conversions;

package body Why.Atree.Mutators is

   -----------------------------
   -- Effects_Append_To_Reads --
   -----------------------------

   procedure Effects_Append_To_Reads
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Identifier_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K3_Reads, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Append_To_Reads;

   ------------------------------
   -- Effects_Prepend_To_Reads --
   ------------------------------

   procedure Effects_Prepend_To_Reads
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Identifier_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K3_Reads, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Prepend_To_Reads;

   -----------------------------
   -- Effects_Append_To_Reads --
   -----------------------------

   procedure Effects_Append_To_Reads
     (Id       : W_Effects_Id;
      New_Item : W_Identifier_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K3_Reads, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Append_To_Reads;

   ------------------------------
   -- Effects_Prepend_To_Reads --
   ------------------------------

   procedure Effects_Prepend_To_Reads
     (Id       : W_Effects_Id;
      New_Item : W_Identifier_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K3_Reads, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Prepend_To_Reads;

   ------------------------------
   -- Effects_Append_To_Writes --
   ------------------------------

   procedure Effects_Append_To_Writes
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Identifier_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K3_Writes, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Append_To_Writes;

   -------------------------------
   -- Effects_Prepend_To_Writes --
   -------------------------------

   procedure Effects_Prepend_To_Writes
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Identifier_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K3_Writes, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Prepend_To_Writes;

   ------------------------------
   -- Effects_Append_To_Writes --
   ------------------------------

   procedure Effects_Append_To_Writes
     (Id       : W_Effects_Id;
      New_Item : W_Identifier_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K3_Writes, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Append_To_Writes;

   -------------------------------
   -- Effects_Prepend_To_Writes --
   -------------------------------

   procedure Effects_Prepend_To_Writes
     (Id       : W_Effects_Id;
      New_Item : W_Identifier_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K3_Writes, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Prepend_To_Writes;

   ------------------------------
   -- Effects_Append_To_Raises --
   ------------------------------

   procedure Effects_Append_To_Raises
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Raise_Effect_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K3_Raises, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Append_To_Raises;

   -------------------------------
   -- Effects_Prepend_To_Raises --
   -------------------------------

   procedure Effects_Prepend_To_Raises
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Raise_Effect_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K3_Raises, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Prepend_To_Raises;

   ------------------------------
   -- Effects_Append_To_Raises --
   ------------------------------

   procedure Effects_Append_To_Raises
     (Id       : W_Effects_Id;
      New_Item : W_Raise_Effect_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K3_Raises, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Append_To_Raises;

   -------------------------------
   -- Effects_Prepend_To_Raises --
   -------------------------------

   procedure Effects_Prepend_To_Raises
     (Id       : W_Effects_Id;
      New_Item : W_Raise_Effect_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K3_Raises, +New_Item);
      Update_Validity_Status
        (+Id,
         Effects_Id_Valid (Why_Node_Id (Id)));
   end Effects_Prepend_To_Raises;

   ---------------------------------------------
   -- Statement_Sequence_Append_To_Statements --
   ---------------------------------------------

   procedure Statement_Sequence_Append_To_Statements
     (Id       : W_Statement_Sequence_Unchecked_Id;
      New_Item : W_Prog_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K46_Statements, +New_Item);
      Update_Validity_Status
        (+Id,
         Statement_Sequence_Id_Valid (Why_Node_Id (Id)));
   end Statement_Sequence_Append_To_Statements;

   ----------------------------------------------
   -- Statement_Sequence_Prepend_To_Statements --
   ----------------------------------------------

   procedure Statement_Sequence_Prepend_To_Statements
     (Id       : W_Statement_Sequence_Unchecked_Id;
      New_Item : W_Prog_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K46_Statements, +New_Item);
      Update_Validity_Status
        (+Id,
         Statement_Sequence_Id_Valid (Why_Node_Id (Id)));
   end Statement_Sequence_Prepend_To_Statements;

   ---------------------------------------------
   -- Statement_Sequence_Append_To_Statements --
   ---------------------------------------------

   procedure Statement_Sequence_Append_To_Statements
     (Id       : W_Statement_Sequence_Id;
      New_Item : W_Prog_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K46_Statements, +New_Item);
      Update_Validity_Status
        (+Id,
         Statement_Sequence_Id_Valid (Why_Node_Id (Id)));
   end Statement_Sequence_Append_To_Statements;

   ----------------------------------------------
   -- Statement_Sequence_Prepend_To_Statements --
   ----------------------------------------------

   procedure Statement_Sequence_Prepend_To_Statements
     (Id       : W_Statement_Sequence_Id;
      New_Item : W_Prog_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K46_Statements, +New_Item);
      Update_Validity_Status
        (+Id,
         Statement_Sequence_Id_Valid (Why_Node_Id (Id)));
   end Statement_Sequence_Prepend_To_Statements;

   -----------------------------------------------
   -- Theory_Declaration_Append_To_Declarations --
   -----------------------------------------------

   procedure Theory_Declaration_Append_To_Declarations
     (Id       : W_Theory_Declaration_Unchecked_Id;
      New_Item : W_Declaration_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K62_Declarations, +New_Item);
      Update_Validity_Status
        (+Id,
         Theory_Declaration_Id_Valid (Why_Node_Id (Id)));
   end Theory_Declaration_Append_To_Declarations;

   ------------------------------------------------
   -- Theory_Declaration_Prepend_To_Declarations --
   ------------------------------------------------

   procedure Theory_Declaration_Prepend_To_Declarations
     (Id       : W_Theory_Declaration_Unchecked_Id;
      New_Item : W_Declaration_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K62_Declarations, +New_Item);
      Update_Validity_Status
        (+Id,
         Theory_Declaration_Id_Valid (Why_Node_Id (Id)));
   end Theory_Declaration_Prepend_To_Declarations;

   -----------------------------------------------
   -- Theory_Declaration_Append_To_Declarations --
   -----------------------------------------------

   procedure Theory_Declaration_Append_To_Declarations
     (Id       : W_Theory_Declaration_Id;
      New_Item : W_Declaration_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K62_Declarations, +New_Item);
      Update_Validity_Status
        (+Id,
         Theory_Declaration_Id_Valid (Why_Node_Id (Id)));
   end Theory_Declaration_Append_To_Declarations;

   ------------------------------------------------
   -- Theory_Declaration_Prepend_To_Declarations --
   ------------------------------------------------

   procedure Theory_Declaration_Prepend_To_Declarations
     (Id       : W_Theory_Declaration_Id;
      New_Item : W_Declaration_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K62_Declarations, +New_Item);
      Update_Validity_Status
        (+Id,
         Theory_Declaration_Id_Valid (Why_Node_Id (Id)));
   end Theory_Declaration_Prepend_To_Declarations;

   ---------------------------------
   -- Theory_Declaration_Set_Name --
   ---------------------------------

   procedure Theory_Declaration_Set_Name
     (Id   : W_Theory_Declaration_Unchecked_Id;
      Name : Symbol)
   is
      Node : Why_Node renames Node_Table (+Id);
   begin
      Node.K62_Name := Name;
      Set_Node (+Id, Node);
   end Theory_Declaration_Set_Name;

   ---------------------------------
   -- Theory_Declaration_Set_Name --
   ---------------------------------

   procedure Theory_Declaration_Set_Name
     (Id   : W_Theory_Declaration_Id;
      Name : Symbol)
   is
      Node : Why_Node renames Node_Table (+Id);
   begin
      Node.K62_Name := Name;
      Set_Node (+Id, Node);
   end Theory_Declaration_Set_Name;

   ---------------------------------
   -- Theory_Declaration_Set_Kind --
   ---------------------------------

   procedure Theory_Declaration_Set_Kind
     (Id   : W_Theory_Declaration_Unchecked_Id;
      Kind : EW_Theory_Type)
   is
      Node : Why_Node renames Node_Table (+Id);
   begin
      Node.K62_Kind := Kind;
      Set_Node (+Id, Node);
   end Theory_Declaration_Set_Kind;

   ---------------------------------
   -- Theory_Declaration_Set_Kind --
   ---------------------------------

   procedure Theory_Declaration_Set_Kind
     (Id   : W_Theory_Declaration_Id;
      Kind : EW_Theory_Type)
   is
      Node : Why_Node renames Node_Table (+Id);
   begin
      Node.K62_Kind := Kind;
      Set_Node (+Id, Node);
   end Theory_Declaration_Set_Kind;

   -------------------------------------------
   -- Theory_Declaration_Append_To_Includes --
   -------------------------------------------

   procedure Theory_Declaration_Append_To_Includes
     (Id       : W_Theory_Declaration_Unchecked_Id;
      New_Item : W_Include_Declaration_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K62_Includes, +New_Item);
      Update_Validity_Status
        (+Id,
         Theory_Declaration_Id_Valid (Why_Node_Id (Id)));
   end Theory_Declaration_Append_To_Includes;

   --------------------------------------------
   -- Theory_Declaration_Prepend_To_Includes --
   --------------------------------------------

   procedure Theory_Declaration_Prepend_To_Includes
     (Id       : W_Theory_Declaration_Unchecked_Id;
      New_Item : W_Include_Declaration_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K62_Includes, +New_Item);
      Update_Validity_Status
        (+Id,
         Theory_Declaration_Id_Valid (Why_Node_Id (Id)));
   end Theory_Declaration_Prepend_To_Includes;

   -------------------------------------------
   -- Theory_Declaration_Append_To_Includes --
   -------------------------------------------

   procedure Theory_Declaration_Append_To_Includes
     (Id       : W_Theory_Declaration_Id;
      New_Item : W_Include_Declaration_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Append (Node.K62_Includes, +New_Item);
      Update_Validity_Status
        (+Id,
         Theory_Declaration_Id_Valid (Why_Node_Id (Id)));
   end Theory_Declaration_Append_To_Includes;

   --------------------------------------------
   -- Theory_Declaration_Prepend_To_Includes --
   --------------------------------------------

   procedure Theory_Declaration_Prepend_To_Includes
     (Id       : W_Theory_Declaration_Id;
      New_Item : W_Include_Declaration_Id)
   is
      Node : Why_Node renames
               Node_Table (+Id);
   begin
      Prepend (Node.K62_Includes, +New_Item);
      Update_Validity_Status
        (+Id,
         Theory_Declaration_Id_Valid (Why_Node_Id (Id)));
   end Theory_Declaration_Prepend_To_Includes;

   ------------------------------------
   -- Theory_Declaration_Set_Comment --
   ------------------------------------

   procedure Theory_Declaration_Set_Comment
     (Id      : W_Theory_Declaration_Unchecked_Id;
      Comment : Symbol)
   is
      Node : Why_Node renames Node_Table (+Id);
   begin
      Node.K62_Comment := Comment;
      Set_Node (+Id, Node);
   end Theory_Declaration_Set_Comment;

   ------------------------------------
   -- Theory_Declaration_Set_Comment --
   ------------------------------------

   procedure Theory_Declaration_Set_Comment
     (Id      : W_Theory_Declaration_Id;
      Comment : Symbol)
   is
      Node : Why_Node renames Node_Table (+Id);
   begin
      Node.K62_Comment := Comment;
      Set_Node (+Id, Node);
   end Theory_Declaration_Set_Comment;

end Why.Atree.Mutators;