------------------------------------------------------------------------------
--                                                                          --
--                            GNAT2WHY COMPONENTS                           --
--                                                                          --
--                  W H Y - A T R E E - T R A V E R S A L                   --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                       Copyright (C) 2010-2025, AdaCore                   --
--                                                                          --
-- gnat2why is  free  software;  you can redistribute  it and/or  modify it --
-- under terms of the  GNU General Public License as published  by the Free --
-- Software  Foundation;  either version 3,  or (at your option)  any later --
-- version.  gnat2why is distributed  in the hope that  it will be  useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of  MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public License  distributed with  gnat2why;  see file COPYING3. --
-- If not,  go to  http://www.gnu.org/licenses  for a complete  copy of the --
-- license.                                                                 --
--                                                                          --
-- gnat2why is maintained by AdaCore (http://www.adacore.com)               --
--                                                                          --
------------------------------------------------------------------------------
--  This package is automatically generated by xtree. Do not edit manually.

with Why.Conversions; use Why.Conversions;
with Why.Sinfo;       use Why.Sinfo;

package body Why.Atree.Traversal is

   --------------
   -- Traverse --
   --------------

   procedure Traverse
     (State : in out Traversal_State'Class;
      Node  : Why_Node_Id) is
   begin
      if State.Control = Terminate_Immediately then
         return;
      end if;

      if State.Control = Abandon_Siblings then
         return;
      end if;

      if Node = Why_Empty then
         return;
      end if;

      case Get_Kind (Node) is
         when W_Type =>
            Type_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K1_Name);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Type_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Name =>
            Name_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K2_Module);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Name_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Effects =>
            Effects_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K3_Reads);
               Traverse_List
                 (State,
                  This_Node.K3_Writes);
               Traverse_List
                 (State,
                  This_Node.K3_Raises);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Effects_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Raise_Effect =>
            Raise_Effect_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K4_Name);
               Traverse
                 (State,
                  This_Node.K4_Arg_Id);
               Traverse
                 (State,
                  This_Node.K4_Post);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Raise_Effect_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Binder =>
            Binder_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K5_Name);
               Traverse
                 (State,
                  This_Node.K5_Arg_Type);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Binder_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Transparent_Type_Definition =>
            Transparent_Type_Definition_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K6_Type_Definition);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Transparent_Type_Definition_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Record_Binder =>
            Record_Binder_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K7_Name);
               Traverse
                 (State,
                  This_Node.K7_Arg_Type);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Record_Binder_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Record_Definition =>
            Record_Definition_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K8_Fields);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Record_Definition_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Range_Type_Definition =>
            Range_Type_Definition_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Range_Type_Definition_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Triggers =>
            Triggers_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K10_Triggers);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Triggers_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Trigger =>
            Trigger_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K11_Terms);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Trigger_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Axiom_Dep =>
            Axiom_Dep_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K12_Name);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Axiom_Dep_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Handler =>
            Handler_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K13_Name);
               Traverse
                 (State,
                  This_Node.K13_Arg_Id);
               Traverse
                 (State,
                  This_Node.K13_Def);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Handler_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Field_Association =>
            Field_Association_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K14_Field);
               Traverse
                 (State,
                  This_Node.K14_Value);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Field_Association_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Variant =>
            Variant_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K15_Cmp_Op);
               Traverse
                 (State,
                  This_Node.K15_Expr);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Variant_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Variants =>
            Variants_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K16_Variants);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Variants_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Universal_Quantif =>
            Universal_Quantif_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K17_Variables);
               Traverse
                 (State,
                  This_Node.K17_Var_Type);
               Traverse
                 (State,
                  This_Node.K17_Triggers);
               Traverse
                 (State,
                  This_Node.K17_Pred);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Universal_Quantif_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Existential_Quantif =>
            Existential_Quantif_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K18_Variables);
               Traverse
                 (State,
                  This_Node.K18_Var_Type);
               Traverse
                 (State,
                  This_Node.K18_Pred);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Existential_Quantif_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Not =>
            Not_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K19_Right);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Not_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Connection =>
            Connection_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K20_Left);
               Traverse
                 (State,
                  This_Node.K20_Right);
               Traverse_List
                 (State,
                  This_Node.K20_More_Right);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Connection_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Label =>
            Label_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K21_Def);
               Traverse
                 (State,
                  This_Node.K21_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Label_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Loc_Label =>
            Loc_Label_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K22_Def);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Loc_Label_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Identifier =>
            Identifier_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K23_Name);
               Traverse
                 (State,
                  This_Node.K23_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Identifier_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Tagged =>
            Tagged_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K24_Def);
               Traverse
                 (State,
                  This_Node.K24_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Tagged_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Call =>
            Call_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K25_Name);
               Traverse_List
                 (State,
                  This_Node.K25_Args);
               Traverse
                 (State,
                  This_Node.K25_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Call_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Literal =>
            Literal_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K26_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Literal_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Binding =>
            Binding_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K27_Name);
               Traverse
                 (State,
                  This_Node.K27_Def);
               Traverse
                 (State,
                  This_Node.K27_Context);
               Traverse
                 (State,
                  This_Node.K27_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Binding_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Elsif =>
            Elsif_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K28_Condition);
               Traverse
                 (State,
                  This_Node.K28_Then_Part);
               Traverse
                 (State,
                  This_Node.K28_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Elsif_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Epsilon =>
            Epsilon_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K29_Name);
               Traverse
                 (State,
                  This_Node.K29_Typ);
               Traverse
                 (State,
                  This_Node.K29_Pred);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Epsilon_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Conditional =>
            Conditional_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K30_Condition);
               Traverse
                 (State,
                  This_Node.K30_Then_Part);
               Traverse_List
                 (State,
                  This_Node.K30_Elsif_Parts);
               Traverse
                 (State,
                  This_Node.K30_Else_Part);
               Traverse
                 (State,
                  This_Node.K30_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Conditional_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Integer_Constant =>
            Integer_Constant_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Integer_Constant_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Range_Constant =>
            Range_Constant_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K32_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Range_Constant_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Modular_Constant =>
            Modular_Constant_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K33_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Modular_Constant_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Fixed_Constant =>
            Fixed_Constant_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K34_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Fixed_Constant_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Real_Constant =>
            Real_Constant_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Real_Constant_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Float_Constant =>
            Float_Constant_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K36_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Float_Constant_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Comment =>
            Comment_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Comment_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Deref =>
            Deref_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K38_Right);
               Traverse
                 (State,
                  This_Node.K38_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Deref_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Record_Access =>
            Record_Access_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K39_Name);
               Traverse
                 (State,
                  This_Node.K39_Field);
               Traverse
                 (State,
                  This_Node.K39_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Record_Access_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Record_Update =>
            Record_Update_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K40_Name);
               Traverse_List
                 (State,
                  This_Node.K40_Updates);
               Traverse
                 (State,
                  This_Node.K40_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Record_Update_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Record_Aggregate =>
            Record_Aggregate_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K41_Associations);
               Traverse
                 (State,
                  This_Node.K41_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Record_Aggregate_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Any_Expr =>
            Any_Expr_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K42_Effects);
               Traverse
                 (State,
                  This_Node.K42_Pre);
               Traverse
                 (State,
                  This_Node.K42_Post);
               Traverse
                 (State,
                  This_Node.K42_Return_Type);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Any_Expr_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Assignment =>
            Assignment_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K43_Name);
               Traverse
                 (State,
                  This_Node.K43_Value);
               Traverse
                 (State,
                  This_Node.K43_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Assignment_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Binding_Ref =>
            Binding_Ref_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K44_Name);
               Traverse
                 (State,
                  This_Node.K44_Def);
               Traverse
                 (State,
                  This_Node.K44_Context);
               Traverse
                 (State,
                  This_Node.K44_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Binding_Ref_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Loop =>
            Loop_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K45_Code_Before);
               Traverse_List
                 (State,
                  This_Node.K45_Invariants);
               Traverse_List
                 (State,
                  This_Node.K45_Variants);
               Traverse
                 (State,
                  This_Node.K45_Code_After);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Loop_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Statement_Sequence =>
            Statement_Sequence_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K46_Statements);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Statement_Sequence_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Abstract_Expr =>
            Abstract_Expr_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K47_Expr);
               Traverse
                 (State,
                  This_Node.K47_Post);
               Traverse
                 (State,
                  This_Node.K47_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Abstract_Expr_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Assert =>
            Assert_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K48_Pred);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Assert_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Raise =>
            Raise_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K49_Name);
               Traverse
                 (State,
                  This_Node.K49_Arg);
               Traverse
                 (State,
                  This_Node.K49_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Raise_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Try_Block =>
            Try_Block_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K50_Prog);
               Traverse_List
                 (State,
                  This_Node.K50_Handler);
               Traverse
                 (State,
                  This_Node.K50_Typ);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Try_Block_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Function_Decl =>
            Function_Decl_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K51_Name);
               Traverse_List
                 (State,
                  This_Node.K51_Binders);
               Traverse
                 (State,
                  This_Node.K51_Effects);
               Traverse
                 (State,
                  This_Node.K51_Pre);
               Traverse
                 (State,
                  This_Node.K51_Post);
               Traverse
                 (State,
                  This_Node.K51_Return_Type);
               Traverse
                 (State,
                  This_Node.K51_Def);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Function_Decl_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Axiom =>
            Axiom_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K52_Def);
               Traverse
                 (State,
                  This_Node.K52_Dep);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Axiom_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Goal =>
            Goal_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K53_Def);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Goal_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Type_Decl =>
            Type_Decl_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K54_Args);
               Traverse
                 (State,
                  This_Node.K54_Name);
               Traverse
                 (State,
                  This_Node.K54_Definition);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Type_Decl_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Global_Ref_Declaration =>
            Global_Ref_Declaration_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K55_Name);
               Traverse
                 (State,
                  This_Node.K55_Ref_Type);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Global_Ref_Declaration_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Namespace_Declaration =>
            Namespace_Declaration_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K56_Declarations);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Namespace_Declaration_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Exception_Declaration =>
            Exception_Declaration_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K57_Name);
               Traverse
                 (State,
                  This_Node.K57_Arg);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Exception_Declaration_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Meta_Declaration =>
            Meta_Declaration_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Meta_Declaration_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Clone_Declaration =>
            Clone_Declaration_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K59_Origin);
               Traverse_List
                 (State,
                  This_Node.K59_Substitutions);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Clone_Declaration_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Clone_Substitution =>
            Clone_Substitution_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K60_Orig_Name);
               Traverse
                 (State,
                  This_Node.K60_Image);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Clone_Substitution_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Include_Declaration =>
            Include_Declaration_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse
                 (State,
                  This_Node.K61_Module);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Include_Declaration_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Theory_Declaration =>
            Theory_Declaration_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            declare
               This_Node : Why_Node renames Node_Table (Node);
            begin
               Traverse_List
                 (State,
                  This_Node.K62_Declarations);
               Traverse_List
                 (State,
                  This_Node.K62_Includes);
            end;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Theory_Declaration_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when W_Module =>
            Module_Pre_Op (State, +Node);

            if State.Control = Abandon_Children then
               State.Control := Continue;
               return;
            end if;

            if State.Control = Abandon_Siblings then
               return;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

            Module_Post_Op (State, +Node);

            if State.Control = Abandon_Siblings then
               State.Control := Continue;
            end if;

            if State.Control = Terminate_Immediately then
               return;
            end if;

         when others =>
            pragma Assert (False);
      end case;
   end Traverse;

   -------------------
   -- Traverse_List --
   -------------------

   procedure Traverse_List
     (State   : in out Traversal_State'Class;
      List_Id : Why_Node_List)
   is
      use Why_Node_Lists;

      Position : Cursor := List_Table (List_Id).Content.First;

   begin
      if State.Control = Terminate_Immediately then
         return;
      end if;

      if State.Control = Abandon_Siblings then
         return;
      end if;

      while Has_Element (Position) loop
         pragma Assert (Has_Element (Position)
                        and then State.Control /= Abandon_Siblings
                        and then State.Control /= Terminate_Immediately);

         declare
            Node : constant Why_Node_Id := Element (Position);
         begin
            Traverse (State, Node);

            exit when State.Control = Abandon_Siblings
              or else State.Control = Terminate_Immediately;
         end;

         Next (Position);
      end loop;
   end Traverse_List;

end Why.Atree.Traversal;