------------------------------------------------------------------------------
--                                                                          --
--                            GNAT2WHY COMPONENTS                           --
--                                                                          --
--                  W H Y - A T R E E - T R A V E R S A L                   --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                       Copyright (C) 2010-2025, AdaCore                   --
--                                                                          --
-- gnat2why is  free  software;  you can redistribute  it and/or  modify it --
-- under terms of the  GNU General Public License as published  by the Free --
-- Software  Foundation;  either version 3,  or (at your option)  any later --
-- version.  gnat2why is distributed  in the hope that  it will be  useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of  MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public License  distributed with  gnat2why;  see file COPYING3. --
-- If not,  go to  http://www.gnu.org/licenses  for a complete  copy of the --
-- license.                                                                 --
--                                                                          --
-- gnat2why is maintained by AdaCore (http://www.adacore.com)               --
--                                                                          --
------------------------------------------------------------------------------
--  This package is automatically generated by xtree. Do not edit manually.

with Why.Ids; use Why.Ids;

package Why.Atree.Traversal is

   type Traverse_Control is
     (Continue,
      --  Continues the normal depth-first traversal

      Abandon_Children,
      --  Prevents traversal of the current element's children

      Abandon_Siblings,
      --  Prevents traversal of the current element's children and remaining
      --  siblings.

      Terminate_Immediately
      --  Does exactly that
      );

   type Traversal_State is abstract tagged record
      Control : Traverse_Control;
   end record;

   procedure Traverse
     (State : in out Traversal_State'Class;
      Node  : Why_Node_Id);

   procedure Traverse_List
     (State   : in out Traversal_State'Class;
      List_Id : Why_Node_List);

   procedure Type_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Type_Id)
     is null;

   procedure Type_Post_Op
     (State : in out Traversal_State;
      Node  : W_Type_Id)
     is null;

   procedure Name_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Name_Id)
     is null;

   procedure Name_Post_Op
     (State : in out Traversal_State;
      Node  : W_Name_Id)
     is null;

   procedure Effects_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Effects_Id)
     is null;

   procedure Effects_Post_Op
     (State : in out Traversal_State;
      Node  : W_Effects_Id)
     is null;

   procedure Raise_Effect_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Raise_Effect_Id)
     is null;

   procedure Raise_Effect_Post_Op
     (State : in out Traversal_State;
      Node  : W_Raise_Effect_Id)
     is null;

   procedure Binder_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Binder_Id)
     is null;

   procedure Binder_Post_Op
     (State : in out Traversal_State;
      Node  : W_Binder_Id)
     is null;

   procedure Transparent_Type_Definition_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Transparent_Type_Definition_Id)
     is null;

   procedure Transparent_Type_Definition_Post_Op
     (State : in out Traversal_State;
      Node  : W_Transparent_Type_Definition_Id)
     is null;

   procedure Record_Binder_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Record_Binder_Id)
     is null;

   procedure Record_Binder_Post_Op
     (State : in out Traversal_State;
      Node  : W_Record_Binder_Id)
     is null;

   procedure Record_Definition_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Record_Definition_Id)
     is null;

   procedure Record_Definition_Post_Op
     (State : in out Traversal_State;
      Node  : W_Record_Definition_Id)
     is null;

   procedure Range_Type_Definition_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Range_Type_Definition_Id)
     is null;

   procedure Range_Type_Definition_Post_Op
     (State : in out Traversal_State;
      Node  : W_Range_Type_Definition_Id)
     is null;

   procedure Triggers_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Triggers_Id)
     is null;

   procedure Triggers_Post_Op
     (State : in out Traversal_State;
      Node  : W_Triggers_Id)
     is null;

   procedure Trigger_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Trigger_Id)
     is null;

   procedure Trigger_Post_Op
     (State : in out Traversal_State;
      Node  : W_Trigger_Id)
     is null;

   procedure Axiom_Dep_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Axiom_Dep_Id)
     is null;

   procedure Axiom_Dep_Post_Op
     (State : in out Traversal_State;
      Node  : W_Axiom_Dep_Id)
     is null;

   procedure Handler_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Handler_Id)
     is null;

   procedure Handler_Post_Op
     (State : in out Traversal_State;
      Node  : W_Handler_Id)
     is null;

   procedure Field_Association_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Field_Association_Id)
     is null;

   procedure Field_Association_Post_Op
     (State : in out Traversal_State;
      Node  : W_Field_Association_Id)
     is null;

   procedure Variant_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Variant_Id)
     is null;

   procedure Variant_Post_Op
     (State : in out Traversal_State;
      Node  : W_Variant_Id)
     is null;

   procedure Variants_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Variants_Id)
     is null;

   procedure Variants_Post_Op
     (State : in out Traversal_State;
      Node  : W_Variants_Id)
     is null;

   procedure Universal_Quantif_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Universal_Quantif_Id)
     is null;

   procedure Universal_Quantif_Post_Op
     (State : in out Traversal_State;
      Node  : W_Universal_Quantif_Id)
     is null;

   procedure Existential_Quantif_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Existential_Quantif_Id)
     is null;

   procedure Existential_Quantif_Post_Op
     (State : in out Traversal_State;
      Node  : W_Existential_Quantif_Id)
     is null;

   procedure Not_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Not_Id)
     is null;

   procedure Not_Post_Op
     (State : in out Traversal_State;
      Node  : W_Not_Id)
     is null;

   procedure Connection_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Connection_Id)
     is null;

   procedure Connection_Post_Op
     (State : in out Traversal_State;
      Node  : W_Connection_Id)
     is null;

   procedure Label_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Label_Id)
     is null;

   procedure Label_Post_Op
     (State : in out Traversal_State;
      Node  : W_Label_Id)
     is null;

   procedure Loc_Label_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Loc_Label_Id)
     is null;

   procedure Loc_Label_Post_Op
     (State : in out Traversal_State;
      Node  : W_Loc_Label_Id)
     is null;

   procedure Identifier_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Identifier_Id)
     is null;

   procedure Identifier_Post_Op
     (State : in out Traversal_State;
      Node  : W_Identifier_Id)
     is null;

   procedure Tagged_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Tagged_Id)
     is null;

   procedure Tagged_Post_Op
     (State : in out Traversal_State;
      Node  : W_Tagged_Id)
     is null;

   procedure Call_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Call_Id)
     is null;

   procedure Call_Post_Op
     (State : in out Traversal_State;
      Node  : W_Call_Id)
     is null;

   procedure Literal_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Literal_Id)
     is null;

   procedure Literal_Post_Op
     (State : in out Traversal_State;
      Node  : W_Literal_Id)
     is null;

   procedure Binding_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Binding_Id)
     is null;

   procedure Binding_Post_Op
     (State : in out Traversal_State;
      Node  : W_Binding_Id)
     is null;

   procedure Elsif_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Elsif_Id)
     is null;

   procedure Elsif_Post_Op
     (State : in out Traversal_State;
      Node  : W_Elsif_Id)
     is null;

   procedure Epsilon_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Epsilon_Id)
     is null;

   procedure Epsilon_Post_Op
     (State : in out Traversal_State;
      Node  : W_Epsilon_Id)
     is null;

   procedure Conditional_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Conditional_Id)
     is null;

   procedure Conditional_Post_Op
     (State : in out Traversal_State;
      Node  : W_Conditional_Id)
     is null;

   procedure Integer_Constant_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Integer_Constant_Id)
     is null;

   procedure Integer_Constant_Post_Op
     (State : in out Traversal_State;
      Node  : W_Integer_Constant_Id)
     is null;

   procedure Range_Constant_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Range_Constant_Id)
     is null;

   procedure Range_Constant_Post_Op
     (State : in out Traversal_State;
      Node  : W_Range_Constant_Id)
     is null;

   procedure Modular_Constant_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Modular_Constant_Id)
     is null;

   procedure Modular_Constant_Post_Op
     (State : in out Traversal_State;
      Node  : W_Modular_Constant_Id)
     is null;

   procedure Fixed_Constant_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Fixed_Constant_Id)
     is null;

   procedure Fixed_Constant_Post_Op
     (State : in out Traversal_State;
      Node  : W_Fixed_Constant_Id)
     is null;

   procedure Real_Constant_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Real_Constant_Id)
     is null;

   procedure Real_Constant_Post_Op
     (State : in out Traversal_State;
      Node  : W_Real_Constant_Id)
     is null;

   procedure Float_Constant_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Float_Constant_Id)
     is null;

   procedure Float_Constant_Post_Op
     (State : in out Traversal_State;
      Node  : W_Float_Constant_Id)
     is null;

   procedure Comment_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Comment_Id)
     is null;

   procedure Comment_Post_Op
     (State : in out Traversal_State;
      Node  : W_Comment_Id)
     is null;

   procedure Deref_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Deref_Id)
     is null;

   procedure Deref_Post_Op
     (State : in out Traversal_State;
      Node  : W_Deref_Id)
     is null;

   procedure Record_Access_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Record_Access_Id)
     is null;

   procedure Record_Access_Post_Op
     (State : in out Traversal_State;
      Node  : W_Record_Access_Id)
     is null;

   procedure Record_Update_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Record_Update_Id)
     is null;

   procedure Record_Update_Post_Op
     (State : in out Traversal_State;
      Node  : W_Record_Update_Id)
     is null;

   procedure Record_Aggregate_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Record_Aggregate_Id)
     is null;

   procedure Record_Aggregate_Post_Op
     (State : in out Traversal_State;
      Node  : W_Record_Aggregate_Id)
     is null;

   procedure Any_Expr_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Any_Expr_Id)
     is null;

   procedure Any_Expr_Post_Op
     (State : in out Traversal_State;
      Node  : W_Any_Expr_Id)
     is null;

   procedure Assignment_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Assignment_Id)
     is null;

   procedure Assignment_Post_Op
     (State : in out Traversal_State;
      Node  : W_Assignment_Id)
     is null;

   procedure Binding_Ref_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Binding_Ref_Id)
     is null;

   procedure Binding_Ref_Post_Op
     (State : in out Traversal_State;
      Node  : W_Binding_Ref_Id)
     is null;

   procedure Loop_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Loop_Id)
     is null;

   procedure Loop_Post_Op
     (State : in out Traversal_State;
      Node  : W_Loop_Id)
     is null;

   procedure Statement_Sequence_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Statement_Sequence_Id)
     is null;

   procedure Statement_Sequence_Post_Op
     (State : in out Traversal_State;
      Node  : W_Statement_Sequence_Id)
     is null;

   procedure Abstract_Expr_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Abstract_Expr_Id)
     is null;

   procedure Abstract_Expr_Post_Op
     (State : in out Traversal_State;
      Node  : W_Abstract_Expr_Id)
     is null;

   procedure Assert_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Assert_Id)
     is null;

   procedure Assert_Post_Op
     (State : in out Traversal_State;
      Node  : W_Assert_Id)
     is null;

   procedure Raise_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Raise_Id)
     is null;

   procedure Raise_Post_Op
     (State : in out Traversal_State;
      Node  : W_Raise_Id)
     is null;

   procedure Try_Block_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Try_Block_Id)
     is null;

   procedure Try_Block_Post_Op
     (State : in out Traversal_State;
      Node  : W_Try_Block_Id)
     is null;

   procedure Function_Decl_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Function_Decl_Id)
     is null;

   procedure Function_Decl_Post_Op
     (State : in out Traversal_State;
      Node  : W_Function_Decl_Id)
     is null;

   procedure Axiom_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Axiom_Id)
     is null;

   procedure Axiom_Post_Op
     (State : in out Traversal_State;
      Node  : W_Axiom_Id)
     is null;

   procedure Goal_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Goal_Id)
     is null;

   procedure Goal_Post_Op
     (State : in out Traversal_State;
      Node  : W_Goal_Id)
     is null;

   procedure Type_Decl_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Type_Decl_Id)
     is null;

   procedure Type_Decl_Post_Op
     (State : in out Traversal_State;
      Node  : W_Type_Decl_Id)
     is null;

   procedure Global_Ref_Declaration_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Global_Ref_Declaration_Id)
     is null;

   procedure Global_Ref_Declaration_Post_Op
     (State : in out Traversal_State;
      Node  : W_Global_Ref_Declaration_Id)
     is null;

   procedure Namespace_Declaration_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Namespace_Declaration_Id)
     is null;

   procedure Namespace_Declaration_Post_Op
     (State : in out Traversal_State;
      Node  : W_Namespace_Declaration_Id)
     is null;

   procedure Exception_Declaration_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Exception_Declaration_Id)
     is null;

   procedure Exception_Declaration_Post_Op
     (State : in out Traversal_State;
      Node  : W_Exception_Declaration_Id)
     is null;

   procedure Meta_Declaration_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Meta_Declaration_Id)
     is null;

   procedure Meta_Declaration_Post_Op
     (State : in out Traversal_State;
      Node  : W_Meta_Declaration_Id)
     is null;

   procedure Clone_Declaration_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Clone_Declaration_Id)
     is null;

   procedure Clone_Declaration_Post_Op
     (State : in out Traversal_State;
      Node  : W_Clone_Declaration_Id)
     is null;

   procedure Clone_Substitution_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Clone_Substitution_Id)
     is null;

   procedure Clone_Substitution_Post_Op
     (State : in out Traversal_State;
      Node  : W_Clone_Substitution_Id)
     is null;

   procedure Include_Declaration_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Include_Declaration_Id)
     is null;

   procedure Include_Declaration_Post_Op
     (State : in out Traversal_State;
      Node  : W_Include_Declaration_Id)
     is null;

   procedure Theory_Declaration_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Theory_Declaration_Id)
     is null;

   procedure Theory_Declaration_Post_Op
     (State : in out Traversal_State;
      Node  : W_Theory_Declaration_Id)
     is null;

   procedure Module_Pre_Op
     (State : in out Traversal_State;
      Node  : W_Module_Id)
     is null;

   procedure Module_Post_Op
     (State : in out Traversal_State;
      Node  : W_Module_Id)
     is null;

end Why.Atree.Traversal;