------------------------------------------------------------------------------
--                                                                          --
--                            GNAT2WHY COMPONENTS                           --
--                                                                          --
--                          W H Y - C L A S S E S                           --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                       Copyright (C) 2010-2025, AdaCore                   --
--                                                                          --
-- gnat2why is  free  software;  you can redistribute  it and/or  modify it --
-- under terms of the  GNU General Public License as published  by the Free --
-- Software  Foundation;  either version 3,  or (at your option)  any later --
-- version.  gnat2why is distributed  in the hope that  it will be  useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of  MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public License  distributed with  gnat2why;  see file COPYING3. --
-- If not,  go to  http://www.gnu.org/licenses  for a complete  copy of the --
-- license.                                                                 --
--                                                                          --
-- gnat2why is maintained by AdaCore (http://www.adacore.com)               --
--                                                                          --
------------------------------------------------------------------------------
--  This package is automatically generated by xtree. Do not edit manually.

with Why.Sinfo; use Why.Sinfo;

package Why.Classes is
   pragma Pure;

   ----------------------------
   -- Node Class Definitions --
   ----------------------------

   subtype W_Expr is Why_Node_Kind range
       W_Universal_Quantif ..
   --  W_Existential_Quantif
   --  W_Not
   --  W_Connection
   --  W_Label
   --  W_Loc_Label
   --  W_Identifier
   --  W_Tagged
   --  W_Call
   --  W_Literal
   --  W_Binding
   --  W_Elsif
   --  W_Epsilon
   --  W_Conditional
   --  W_Integer_Constant
   --  W_Range_Constant
   --  W_Modular_Constant
   --  W_Fixed_Constant
   --  W_Real_Constant
   --  W_Float_Constant
   --  W_Comment
   --  W_Deref
   --  W_Record_Access
   --  W_Record_Update
   --  W_Record_Aggregate
   --  W_Any_Expr
   --  W_Assignment
   --  W_Binding_Ref
   --  W_Loop
   --  W_Statement_Sequence
   --  W_Abstract_Expr
   --  W_Assert
   --  W_Raise
       W_Try_Block;

   subtype W_Pred is Why_Node_Kind range
       W_Universal_Quantif ..
   --  W_Existential_Quantif
   --  W_Not
   --  W_Connection
   --  W_Label
   --  W_Loc_Label
   --  W_Identifier
   --  W_Tagged
   --  W_Call
   --  W_Literal
   --  W_Binding
   --  W_Elsif
   --  W_Epsilon
       W_Conditional;

   subtype W_Term is Why_Node_Kind range
       W_Label ..
   --  W_Loc_Label
   --  W_Identifier
   --  W_Tagged
   --  W_Call
   --  W_Literal
   --  W_Binding
   --  W_Elsif
   --  W_Epsilon
   --  W_Conditional
   --  W_Integer_Constant
   --  W_Range_Constant
   --  W_Modular_Constant
   --  W_Fixed_Constant
   --  W_Real_Constant
   --  W_Float_Constant
   --  W_Comment
   --  W_Deref
   --  W_Record_Access
   --  W_Record_Update
       W_Record_Aggregate;

   subtype W_Prog is Why_Node_Kind range
       W_Not ..
   --  W_Connection
   --  W_Label
   --  W_Loc_Label
   --  W_Identifier
   --  W_Tagged
   --  W_Call
   --  W_Literal
   --  W_Binding
   --  W_Elsif
   --  W_Epsilon
   --  W_Conditional
   --  W_Integer_Constant
   --  W_Range_Constant
   --  W_Modular_Constant
   --  W_Fixed_Constant
   --  W_Real_Constant
   --  W_Float_Constant
   --  W_Comment
   --  W_Deref
   --  W_Record_Access
   --  W_Record_Update
   --  W_Record_Aggregate
   --  W_Any_Expr
   --  W_Assignment
   --  W_Binding_Ref
   --  W_Loop
   --  W_Statement_Sequence
   --  W_Abstract_Expr
   --  W_Assert
   --  W_Raise
       W_Try_Block;

   subtype W_Type_Definition is Why_Node_Kind range
       W_Transparent_Type_Definition ..
   --  W_Record_Binder
   --  W_Record_Definition
       W_Range_Type_Definition;

   subtype W_Declaration is Why_Node_Kind range
       W_Function_Decl ..
   --  W_Axiom
   --  W_Goal
   --  W_Type_Decl
   --  W_Global_Ref_Declaration
   --  W_Namespace_Declaration
   --  W_Exception_Declaration
   --  W_Meta_Declaration
       W_Clone_Declaration;

   subtype W_Any_Node is Why_Node_Kind range
       W_Type ..
   --  W_Name
   --  W_Effects
   --  W_Raise_Effect
   --  W_Binder
   --  W_Transparent_Type_Definition
   --  W_Record_Binder
   --  W_Record_Definition
   --  W_Range_Type_Definition
   --  W_Triggers
   --  W_Trigger
   --  W_Axiom_Dep
   --  W_Handler
   --  W_Field_Association
   --  W_Variant
   --  W_Variants
   --  W_Universal_Quantif
   --  W_Existential_Quantif
   --  W_Not
   --  W_Connection
   --  W_Label
   --  W_Loc_Label
   --  W_Identifier
   --  W_Tagged
   --  W_Call
   --  W_Literal
   --  W_Binding
   --  W_Elsif
   --  W_Epsilon
   --  W_Conditional
   --  W_Integer_Constant
   --  W_Range_Constant
   --  W_Modular_Constant
   --  W_Fixed_Constant
   --  W_Real_Constant
   --  W_Float_Constant
   --  W_Comment
   --  W_Deref
   --  W_Record_Access
   --  W_Record_Update
   --  W_Record_Aggregate
   --  W_Any_Expr
   --  W_Assignment
   --  W_Binding_Ref
   --  W_Loop
   --  W_Statement_Sequence
   --  W_Abstract_Expr
   --  W_Assert
   --  W_Raise
   --  W_Try_Block
   --  W_Function_Decl
   --  W_Axiom
   --  W_Goal
   --  W_Type_Decl
   --  W_Global_Ref_Declaration
   --  W_Namespace_Declaration
   --  W_Exception_Declaration
   --  W_Meta_Declaration
   --  W_Clone_Declaration
   --  W_Clone_Substitution
   --  W_Include_Declaration
   --  W_Theory_Declaration
       W_Module;

end Why.Classes;